import os, getpass
module_cache = os.path.join(os.path.dirname(__file__), '.caches', 'data')

def run():
    print "Startup"

    fu = bmd.scriptapp('Fusion')
    resolve = bmd.scriptapp('Resolve')

    ui = fu.UIManager
    disp = bmd.UIDispatcher(ui)

    win = disp.AddWindow(
        {
            'ID': "ScriptWindow",
            'WindowTitle': "Script",
            'Geometry': {1: 100, 2: 100, 3: 500, 4: 300},
            1: ui.VGroup({
                'ID': "root",
                1: ui.HGroup({
                    'Weight': 1,
                    1: ui.TextEdit({
                        'ID': 'Script',
                        'TabStopWidth': 28,
                        'LineWrapMode': 'NoWrap',
                        'AcceptRichText': False,
                        'Lexer': 'python',
                    }),
                }),
                2: ui.HGroup({
                    'Weight': 0,
                    1: ui.Button({'ID': "Open", 'Text': "Open"}),
                    2: ui.HGap(5),
                    3: ui.Button({'ID': "Save", 'Text': "Save"}),
                    4: ui.HGap(5),
                    5: ui.Button({'ID': "Exec", 'Text': "Exec"}),
                    6: ui.HGap(0, 2),
                }),
            })
        }
    )

    itm = win.GetItems()

    def save_cache():
        try:
            os.makedirs(os.path.dirname(module_cache))
        except OSError:
            pass
        with open(module_cache + getpass.getuser(), 'w') as fs:
            fs.write(itm.get('Script').PlainText)

    def open_file(ev):
        file_to_open = fu.RequestFile()
        if file_to_open:
            with open(file_to_open) as fs:
                itm.get('Script').PlainText = fs.read()
        save_cache()

    def save_file(ev):
        file_to_save = fu.RequestFile()
        if file_to_save:
            with open(file_to_save, 'w') as fs:
                fs.write(itm.get('Script').PlainText)
        save_cache()

    def exec_script(ev):
        save_cache()
        script = itm.get('Script').PlainText
        _locals = locals()
        _locals.update(dict(
            ResolveAPI = resolve,
            FusionAPI = fu
        ))
        print("AVAILABLE VARIABLE:\n" + '-' * 20 +
              '\n%s\n' % '\n'.join("%s: %s" % (key, value) for (key, value) in _locals.items()) + '-' * 20)

        print("EXEC:\n" + '-' * 20 + '\n%s\n' % script + '-' * 20)
        try:
            exec(script, globals(), _locals)
        except Exception:
            import traceback
            print("ERROR:\n" + '-' * 20 + '\n%s\n' % traceback.format_exc() + '-' * 20)

    def close(ev):
        disp.ExitLoop()

    win.On.Open.Clicked = open_file
    win.On.Save.Clicked = save_file
    win.On.Exec.Clicked = exec_script
    win.On.ScriptWindow.Close = close

    try:
        with open(module_cache + getpass.getuser()) as fs:
            itm.get('Script').PlainText = fs.read()
    except (OSError, IOError):
        pass

    win.Show()

    disp.RunLoop()

    win.Hide()